/*{ cm3_basic.h ***********************************************
 *
 * TheToolChain.com
 *
 * Written by Gregor Rebel, Sascha Poggemann 2010-2012
 *
 * Basic datatypes, enums and functions additional to cm3_basic.h
 * 
}*/

#ifndef EM357_BASIC_H
#define EM357_BASIC_H

//{ includes *************************************************************


#include <stdint.h>
#include "cm3_basic.h"

// define basic datatypes required to include HAL-Library
typedef unsigned long uint32_t;
typedef u16_t uint16_t;
typedef  u8_t uint8_t;

#include "micro/cortexm3/compiler/gnu.h"
#include "stm32w108xx_sc.h"
#include "micro/cortexm3/stm32w108/board.h"
#include "hal.h"

//} includes *************************************************************
//{ types ****************************************************************


// shall be defined by stdint.h
#ifndef __int32_t_defined
typedef s32_t int32_t;
typedef s16_t int16_t;
typedef  s8_t int8_t;
#endif

//} types ****************************************************************
//{ macros ***************************************************************

#define assert_param(CONDITION) Assert_On_False(CONDITION)

//} macros ***************************************************************
//{ includes2 ************************************************************

//? #include "regs.h"
//? #include "stm32w108_type.h"
#include "micro-common.h"

//} includes2 ************************************************************
//{ Function prototypes **************************************************

/* basic hardware initialization
 */
void em357_hardware_init();

//} Function prototypes **************************************************

#endif
