/*{ radio_cc1120_registers.h ********************************************************

 This source is published under the GNU LESSER GENERAL PUBLIC LICENSE (LGPL).
 See file LEGAL.txt in this software package for details.

 Authors: <Sascha Poggemann>, <Gregor Rebel>

 Description: Register definitions and structures of spi-controlled cc1120 radio transceiver

}*/
#ifndef RADIO_CC1120_REGISTERS_H
#define RADIO_CC1120_REGISTERS_H

//{ register address definitions ***************************************************

//{ Configuration Registers
//typedef enum {

    //ToDo: due to 0x2Fxx very large enum maybe change to defines.

    /* configuration registers */
#define  rcr_CC112X_IOCFG3                0x0000
#define  rcr_CC112X_IOCFG2                0x0001
#define  rcr_CC112X_IOCFG1                0x0002
#define  rcr_CC112X_IOCFG0                0x0003
#define  rcr_CC112X_SYNC3                 0x0004
#define  rcr_CC112X_SYNC2                 0x0005
#define  rcr_CC112X_SYNC1                 0x0006
#define  rcr_CC112X_SYNC0                 0x0007
#define  rcr_CC112X_SYNC_CFG1             0x0008
#define  rcr_CC112X_SYNC_CFG0             0x0009
#define  rcr_CC112X_DEVIATION_M           0x000A
#define  rcr_CC112X_MODCFG_DEV_E          0x000B
#define  rcr_CC112X_DCFILT_CFG            0x000C
#define  rcr_CC112X_PREAMBLE_CFG1         0x000D
#define  rcr_CC112X_PREAMBLE_CFG0         0x000E
#define  rcr_CC112X_FREQ_IF_CFG           0x000F
#define  rcr_CC112X_IQIC                  0x0010
#define  rcr_CC112X_CHAN_BW               0x0011
#define  rcr_CC112X_MDMCFG1               0x0012
#define  rcr_CC112X_MDMCFG0               0x0013
#define  rcr_CC112X_DRATE2                0x0014
#define  rcr_CC112X_DRATE1                0x0015
#define  rcr_CC112X_DRATE0                0x0016
#define  rcr_CC112X_AGC_REF               0x0017
#define  rcr_CC112X_AGC_CS_THR            0x0018
#define  rcr_CC112X_AGC_GAIN_ADJUST       0x0019
#define  rcr_CC112X_AGC_CFG3              0x001A
#define  rcr_CC112X_AGC_CFG2              0x001B
#define  rcr_CC112X_AGC_CFG1              0x001C
#define  rcr_CC112X_AGC_CFG0              0x001D
#define  rcr_CC112X_FIFO_CFG              0x001E
#define  rcr_CC112X_DEV_ADDR              0x001F
#define  rcr_CC112X_SETTLING_CFG          0x0020
#define  rcr_CC112X_FS_CFG                0x0021
#define  rcr_CC112X_WOR_CFG1              0x0022
#define  rcr_CC112X_WOR_CFG0              0x0023
#define  rcr_CC112X_WOR_EVENT0_MSB        0x0024
#define  rcr_CC112X_WOR_EVENT0_LSB        0x0025
#define  rcr_CC112X_PKT_CFG2              0x0026
#define  rcr_CC112X_PKT_CFG1              0x0027
#define  rcr_CC112X_PKT_CFG0              0x0028
#define  rcr_CC112X_RFEND_CFG1            0x0029
#define  rcr_CC112X_RFEND_CFG0            0x002A
#define  rcr_CC112X_PA_CFG2               0x002B
#define  rcr_CC112X_PA_CFG1               0x002C
#define  rcr_CC112X_PA_CFG0               0x002D
#define  rcr_CC112X_PKT_LEN               0x002E

    /* Extended Configuration Registers */
#define  rcr_CC112X_IF_MIX_CFG            0x2F00
#define  rcr_CC112X_FREQOFF_CFG           0x2F01
#define  rcr_CC112X_TOC_CFG               0x2F02
#define  rcr_CC112X_MARC_SPARE            0x2F03
#define  rcr_CC112X_ECG_CFG               0x2F04
#define  rcr_CC112X_SOFT_TX_DATA_CFG      0x2F05
#define  rcr_CC112X_EXT_CTRL              0x2F06
#define  rcr_CC112X_RCCAL_FINE            0x2F07
#define  rcr_CC112X_RCCAL_COARSE          0x2F08
#define  rcr_CC112X_RCCAL_OFFSET          0x2F09
#define  rcr_CC112X_FREQOFF1              0x2F0A
#define  rcr_CC112X_FREQOFF0              0x2F0B
#define  rcr_CC112X_FREQ2                 0x2F0C
#define  rcr_CC112X_FREQ1                 0x2F0D
#define  rcr_CC112X_FREQ0                 0x2F0E
#define  rcr_CC112X_IF_ADC2               0x2F0F
#define  rcr_CC112X_IF_ADC1               0x2F10
#define  rcr_CC112X_IF_ADC0               0x2F11
#define  rcr_CC112X_FS_DIG1               0x2F12
#define  rcr_CC112X_FS_DIG0               0x2F13
#define  rcr_CC112X_FS_CAL3               0x2F14
#define  rcr_CC112X_FS_CAL2               0x2F15
#define  rcr_CC112X_FS_CAL1               0x2F16
#define  rcr_CC112X_FS_CAL0               0x2F17
#define  rcr_CC112X_FS_CHP                0x2F18
#define  rcr_CC112X_FS_DIVTWO             0x2F19
#define  rcr_CC112X_FS_DSM1               0x2F1A
#define  rcr_CC112X_FS_DSM0               0x2F1B
#define  rcr_CC112X_FS_DVC1               0x2F1C
#define  rcr_CC112X_FS_DVC0               0x2F1D
#define  rcr_CC112X_FS_LBI                0x2F1E
#define  rcr_CC112X_FS_PFD                0x2F1F
#define  rcr_CC112X_FS_PRE                0x2F20
#define  rcr_CC112X_FS_REG_DIV_CML        0x2F21
#define  rcr_CC112X_FS_SPARE              0x2F22
#define  rcr_CC112X_FS_VCO4               0x2F23
#define  rcr_CC112X_FS_VCO3               0x2F24
#define  rcr_CC112X_FS_VCO2               0x2F25
#define  rcr_CC112X_FS_VCO1               0x2F26
#define  rcr_CC112X_FS_VCO0               0x2F27
#define  rcr_CC112X_GBIAS6                0x2F28
#define  rcr_CC112X_GBIAS5                0x2F29
#define  rcr_CC112X_GBIAS4                0x2F2A
#define  rcr_CC112X_GBIAS3                0x2F2B
#define  rcr_CC112X_GBIAS2                0x2F2C
#define  rcr_CC112X_GBIAS1                0x2F2D
#define  rcr_CC112X_GBIAS0                0x2F2E
#define  rcr_CC112X_IFAMP                 0x2F2F
#define  rcr_CC112X_LNA                   0x2F30
#define  rcr_CC112X_RXMIX                 0x2F31
#define  rcr_CC112X_XOSC5                 0x2F32
#define  rcr_CC112X_XOSC4                 0x2F33
#define  rcr_CC112X_XOSC3                 0x2F34
#define  rcr_CC112X_XOSC2                 0x2F35
#define  rcr_CC112X_XOSC1                 0x2F36
#define  rcr_CC112X_XOSC0                 0x2F37
#define  rcr_CC112X_ANALOG_SPARE          0x2F38
#define  rcr_CC112X_PA_CFG3               0x2F39
#define  rcr_CC112X_IRQ0M                 0x2F3F
#define  rcr_CC112X_IRQ0F                 0x2F40

    /* Status Registers */
#define  rcr_CC112X_WOR_TIME1             0x2F64
#define  rcr_CC112X_WOR_TIME0             0x2F65
#define  rcr_CC112X_WOR_CAPTURE1          0x2F66
#define  rcr_CC112X_WOR_CAPTURE0          0x2F67
#define  rcr_CC112X_BIST                  0x2F68
#define  rcr_CC112X_DCFILTOFFSET_I1       0x2F69
#define  rcr_CC112X_DCFILTOFFSET_I0       0x2F6A
#define  rcr_CC112X_DCFILTOFFSET_Q1       0x2F6B
#define  rcr_CC112X_DCFILTOFFSET_Q0       0x2F6C
#define  rcr_CC112X_IQIE_I1               0x2F6D
#define  rcr_CC112X_IQIE_I0               0x2F6E
#define  rcr_CC112X_IQIE_Q1               0x2F6F
#define  rcr_CC112X_IQIE_Q0               0x2F70
#define  rcr_CC112X_RSSI1                 0x2F71
#define  rcr_CC112X_RSSI0                 0x2F72
#define  rcr_CC112X_MARCSTATE             0x2F73
#define  rcr_CC112X_LQI_VAL               0x2F74
#define  rcr_CC112X_PQT_SYNC_ERR          0x2F75
#define  rcr_CC112X_DEM_STATUS            0x2F76
#define  rcr_CC112X_FREQOFF_EST1          0x2F77
#define  rcr_CC112X_FREQOFF_EST0          0x2F78
#define  rcr_CC112X_AGC_GAIN3             0x2F79
#define  rcr_CC112X_AGC_GAIN2             0x2F7A
#define  rcr_CC112X_AGC_GAIN1             0x2F7B
#define  rcr_CC112X_AGC_GAIN0             0x2F7C
#define  rcr_CC112X_SOFT_RX_DATA_OUT      0x2F7D
#define  rcr_CC112X_SOFT_TX_DATA_IN       0x2F7E
#define  rcr_CC112X_ASK_SOFT_RX_DATA      0x2F7F
#define  rcr_CC112X_RNDGEN                0x2F80
#define  rcr_CC112X_MAGN2                 0x2F81
#define  rcr_CC112X_MAGN1                 0x2F82
#define  rcr_CC112X_MAGN0                 0x2F83
#define  rcr_CC112X_ANG1                  0x2F84
#define  rcr_CC112X_ANG0                  0x2F85
#define  rcr_CC112X_CHFILT_I2             0x2F86
#define  rcr_CC112X_CHFILT_I1             0x2F87
#define  rcr_CC112X_CHFILT_I0             0x2F88
#define  rcr_CC112X_CHFILT_Q2             0x2F89
#define  rcr_CC112X_CHFILT_Q1             0x2F8A
#define  rcr_CC112X_CHFILT_Q0             0x2F8B
#define  rcr_CC112X_GPIO_STATUS           0x2F8C
#define  rcr_CC112X_FSCAL_CTRL            0x2F8D
#define  rcr_CC112X_PHASE_ADJUST          0x2F8E
#define  rcr_CC112X_PARTNUMBER            0x2F8F
#define  rcr_CC112X_PARTVERSION           0x2F90
#define  rcr_CC112X_SERIAL_STATUS         0x2F91
#define  rcr_CC112X_RX_STATUS             0x2F92
#define  rcr_CC112X_TX_STATUS             0x2F93
#define  rcr_CC112X_MARC_STATUS1          0x2F94
#define  rcr_CC112X_MARC_STATUS0          0x2F95
#define  rcr_CC112X_PA_IFAMP_TEST         0x2F96
#define  rcr_CC112X_FSRF_TEST             0x2F97
#define  rcr_CC112X_PRE_TEST              0x2F98
#define  rcr_CC112X_PRE_OVR               0x2F99
#define  rcr_CC112X_ADC_TEST              0x2F9A
#define  rcr_CC112X_DVC_TEST              0x2F9B
#define  rcr_CC112X_ATEST                 0x2F9C
#define  rcr_CC112X_ATEST_LVDS            0x2F9D
#define  rcr_CC112X_ATEST_MODE            0x2F9E
#define  rcr_CC112X_XOSC_TEST1            0x2F9F
#define  rcr_CC112X_XOSC_TEST0            0x2FA0

    /* DATA FIFO Access Registers */
#define  rcr_CC112X_RXFIRST               0x2FD2
#define  rcr_CC112X_TXFIRST               0x2FD3
#define  rcr_CC112X_RXLAST                0x2FD4
#define  rcr_CC112X_TXLAST                0x2FD5
#define  rcr_CC112X_NUM_TXBYTES           0x2FD6    /* Number of bytes in TXFIFO */
#define  rcr_CC112X_NUM_RXBYTES           0x2FD7    /* Number of bytes in RXFIFO */
#define  rcr_CC112X_FIFO_NUM_TXBYTES      0x2FD8
#define  rcr_CC112X_FIFO_NUM_RXBYTES      0x2FD9

    /* DATA FIFO Access */
#define  rcr_CC112X_SINGLE_TXFIFO         0x003F    /*  TXFIFO  - Single accecss to Transmit FIFO  */
#define  rcr_CC112X_BURST_TXFIFO          0x007F    /*  TXFIFO  - Burst  accecss to Transmit FIFO  */
#define  rcr_CC112X_SINGLE_RXFIFO         0x00BF    /*  RXFIFO  - Single accecss to Receive  FIFO  */
#define  rcr_CC112X_BURST_RXFIFO          0x00FF    /*  RXFIFO  - Burst  accecss to Receive  FIFO  */

#define CC112X_LQI_CRC_OK_BM            0x80
#define CC112X_LQI_EST_BM               0x7F

/* Radio Command strobe (rcs) registers */
#define rcs_CC112X_SRES                 0x30      /*  SRES    - Reset chip. */
#define rcs_CC112X_SFSTXON              0x31      /*  SFSTXON - Enable and calibrate frequency synthesizer. */
#define rcs_CC112X_SXOFF                0x32      /*  SXOFF   - Turn off crystal oscillator. */
#define rcs_CC112X_SCAL                 0x33      /*  SCAL    - Calibrate frequency synthesizer and turn it off. */
#define rcs_CC112X_SRX                  0x34      /*  SRX     - Enable RX. Perform calibration if enabled. */
#define rcs_CC112X_STX                  0x35      /*  STX     - Enable TX. If in RX state, only enable TX if CCA passes. */
#define rcs_CC112X_SIDLE                0x36      /*  SIDLE   - Exit RX / TX, turn off frequency synthesizer. */
#define rcs_CC112X_AFC                  0x37      /*  AFC     - Automatic Frequency Correction */
#define rcs_CC112X_SWOR                 0x38      /*  SWOR    - Start automatic RX polling sequence (Wake-on-Radio) */
#define rcs_CC112X_SPWD                 0x39      /*  SPWD    - Enter power down mode when CSn goes high. */
#define rcs_CC112X_SFRX                 0x3A      /*  SFRX    - Flush the RX FIFO buffer. */
#define rcs_CC112X_SFTX                 0x3B      /*  SFTX    - Flush the TX FIFO buffer. */
#define rcs_CC112X_SWORRST              0x3C      /*  SWORRST - Reset real time clock. */
#define rcs_CC112X_SNOP                 0x3D      /*  SNOP    - No operation. Returns status byte. */

/* Chip states returned in status byte */
#define CC112X_STATE_IDLE               0x00
#define CC112X_STATE_RX                 0x10
#define CC112X_STATE_TX                 0x20
#define CC112X_STATE_FSTXON             0x30
#define CC112X_STATE_CALIBRATE          0x40
#define CC112X_STATE_SETTLING           0x50
#define CC112X_STATE_RXFIFO_ERROR       0x60
#define CC112X_STATE_TXFIFO_ERROR       0x70


//} register content definitions

#endif //RADIO_CC1120_REGISTERS_H
