#ifndef STM32_SPI_TYPES_H
#define STM32_SPI_TYPES_H

/*{ stm32_spi.h **********************************************************
 
                      The ToolChain
                      
   Universal Synchronous Asynchronous Receiver and Transmitters (SPIs)
   for ARM CortexM3 microcontrollers.
   Currently tested to comply to STM32F10x types.
   
   written by Gregor Rebel 2012

 
}*/
//{ Defines/ TypeDefs ****************************************************


//} Defines
//{ Includes *************************************************************

#include "stm32_gpio.h"
#include "stm32_registers.h"

//} Includes
//{ Structures/ Enums required by ttc_spi_types.h *************************

typedef struct {  // architecture specific configuration data of single SPI 
  SPI_t*       Base;       // base address of SPI registers
  stm32_Port_t PortMISO;   // port pin for MISO
  stm32_Port_t PortMOSI;   // port pin for MOSI
  stm32_Port_t PortSCK;    // port pin for SCK
  stm32_Port_t PortNSS;    // port pin for NSS
} __attribute__((__packed__)) stm32_spi_architecture_t;

typedef stm32_spi_architecture_t ttc_spi_architecture_t;

//} Structures/ Enums


#endif //STM32_SPI_TYPES_H
