/*{ ttc_input.c *******************************



}*/

#include "ttc_input.h"

//{ Global Variables *****************************************************

tit_InputArea_t* InputAreas_Used  = NULL;
tit_InputArea_t* InputAreas_Empty = NULL;
tit_InputArea_t* InputArea_Current      = NULL;

tit_Pen_Holder_t Pen_Point;


//} Global Variables
//{ Function definitions *************************************************

void ttc_input_init() {
    InputArea_Current = InputAreas_Used;
    Pen_Point.ChipVersion=0;
    if(0)
      ttc_input_callibrate();
    else
      Pen_Point.ChipVersion=1;
}
void ttc_input_callibrate() {

#ifdef TTC_GFX

    ttc_input_setBackgroundColor(0xFFFFFF);
    ttc_input_clear();
    ttc_input_setCursor(10,10);
    ttc_input_string("Please tip into the circle to callibrate the Touch-Screen");
    ttc_input_circle(220,300,10);
    while(input_input_ads7843_read_position(&Pen_Point.X,&Pen_Point.Y)==0){
        mSleep(1);
    }
    if(Pen_Point.X>5&&Pen_Point.X<35&&Pen_Point.Y>5&&Pen_Point.Y<35)
        Pen_Point.ChipVersion=1;
    else
        Pen_Point.ChipVersion=0;
    ttc_input_setCursor(50,140);
    ttc_input_string("OK");
#else
    return;
#endif

}
void ttc_input_start() {
    ttc_input_init();

    ttc_task_create(ttc_input_maintask,
                    "TouchStart",
                    1024,
                    NULL,
                    50,
                    NULL);


}
void ttc_input_maintask(void* pvParameters) {
    (void) pvParameters;

    while (1) {
        u16_t X,Y,sumX[MEDIUMLENGHT],sumY[MEDIUMLENGHT];
        mSleep(10);

        if(InputArea_Current->CurrentEvent==me_MouseUp)
            InputArea_Current->CurrentEvent=me_noEvent;
        if((InputArea_Current->CurrentEvent==me_MouseMove)||InputArea_Current->CurrentEvent==me_MouseDown)
            InputArea_Current->CurrentEvent=me_MouseUp;

        while (input_ads7843_read_position(&X,&Y)) { //get Touchpanel info, if touchpanel activ, go into while loop

            X=0;
            Y=0;
            u8_t i=0;
            mSleep(5);
            for(i=0;(i<MEDIUMLENGHT)&&(input_ads7843_read_position(&X,&Y));i++) //take average vaule
            {
                input_ads7843_read_position(&X,&Y); //take average vaule
                sumX[i]=X; //take average vaule]
                sumY[i]=Y; //take average vaule
                uSleep(100); //take average vaule
            } //take average vaule

            X=0;
            Y=0;

            if(i<9)            //if there was a value out of the range of the touchpanel -> break
                break;

            for(i=0;i<MEDIUMLENGHT;i++) {
                X=X+sumX[i];
                Y=Y+sumY[i];
            }

            X=X/MEDIUMLENGHT;
            Y=Y/MEDIUMLENGHT;

            for(tit_InputArea_t* InputArea = InputAreas_Used ; InputArea ;InputArea= InputArea->Next) //check every input area until activ input area is empty
            {
                if(InputArea->Left<X&&InputArea->Right>X&&InputArea->Top<Y&&InputArea->Bottom>Y)  //check : fit any input area?
                {
                    InputArea_Current = InputArea;

                    if(InputArea_Current->CurrentEvent==me_MouseDown)
                        InputArea_Current->CurrentEvent=me_MouseMove;
                    if(InputArea_Current->CurrentEvent==me_noEvent)
                        InputArea_Current->CurrentEvent=me_MouseDown;

                    if(InputArea_Current->CurrentEvent==InputArea_Current->Event)
                    InputArea_Current->inputAreaHandler(InputArea_Current,X,Y);
                    X=0;
                    Y=0;
                    break;
                }
            }

        }

        if((InputArea_Current->CurrentEvent==InputArea_Current->Event)&&(InputArea_Current->CurrentEvent==me_MouseUp))
        InputArea_Current->inputAreaHandler(InputArea_Current,X,Y);

    }
}
void ttc_input_register_input_area(void (*TouchHandler)(void* Argument), void* Argument, u16_t Left, u16_t Top, u16_t Right, u16_t Bottom, const char* Text, tit_InputAreaShape_e Shape) {

}
bool ttc_input_check_touch(tit_ButtonData_t* ButtonData) {
    u16_t X,Y,sumX,sumY;
    input_ads7843_read_position(&X,&Y);
    if(ButtonData->Area.Left<X&&ButtonData->Area.Right>X&&ButtonData->Area.Top<Y&&ButtonData->Area.Bottom>Y)
    {
        mSleep(2);
        input_ads7843_read_position(&X,&Y);
        if(ButtonData->Area.Left<X&&ButtonData->Area.Right>X&&ButtonData->Area.Top<Y&&ButtonData->Area.Bottom>Y){
            for(u8_t i=0;i<10;i++)
            {
                input_ads7843_read_position(&X,&Y);
                sumX=(X+sumX)/2;
                sumY=(Y+sumY)/2;
                mSleep(2);
            }
            if(ButtonData->Area.Left<sumX&&ButtonData->Area.Right>sumX&&ButtonData->Area.Top<sumY&&ButtonData->Area.Bottom>sumY){
                ButtonData->TouchHandler(ButtonData);
                return 1;
            }
        }

    }

    return 0;
}
void ttc_input_delete_all_input_areas() {
    if (InputAreas_Used) {
      if (InputAreas_Empty) { // move all current input areas after last unused input area
        tit_InputArea_t* Last_UnusedArea = InputAreas_Empty;
        while (Last_UnusedArea->Next)
          Last_UnusedArea = Last_UnusedArea->Next;
        Last_UnusedArea->Next = InputAreas_Used;
      }
      else {
        InputAreas_Empty = InputAreas_Used;
      }
      InputAreas_Used = NULL;
    }
}
void ttc_input_delete_input_area(tit_InputArea_t* DeleteArea) {
    
  if (!DeleteArea) 
    return;
  
  tit_InputArea_t* InputArea = InputAreas_Used;
    
  while ( InputArea && (InputArea->Next != DeleteArea) ) {
        InputArea = InputArea->Next;
  }
  
  if ( InputArea &&
       (InputArea->Next == DeleteArea)
     )
      InputArea->Next = DeleteArea->Next;
}
void ttc_input_RegisterTouchHandler(void (*TouchHandler)(void* Argument), void* Argument, u16_t Left, u16_t Top, u16_t Right, u16_t Bottom, const char* Text, tit_InputAreaShape_e Shape){
#ifdef IL9320
    //il9320_RegisterTouchHandler(*TouchHandler,Argument,Left,Top,Right,Bottom,Text,Shape);
#endif
}
tit_ButtonData_t* ttc_input_get_first_button(){ // ToDo: deprecated?
#ifdef IL9320
//return il9320_Get_First_ButtonData_s();
#endif
return NULL;
}
BOOL ttc_input_get_touch_position(u16_t *X,u16_t *Y) {
#ifdef EXTENSION_400_input_ads7843
    return input_ads7843_read_position(X,Y);
#else
    return FALSE
#endif
}
tit_InputArea_t* ttc_input_get_empty_input_area() {

    //??? tit_InputArea_t* EmptyBlock = InputAreas_Used;
    tit_InputArea_t* EmptyBlock = NULL;

    if (InputAreas_Empty) {
        EmptyBlock = InputAreas_Empty;               // quarry out the new block out of the unused blocks, the new block is the first element of the old unused block list
        InputAreas_Empty = EmptyBlock->Next;         // the second block of the old list is the first block of the new list now
    }
    else {
        EmptyBlock = (tit_InputArea_t*) ttc_memory_alloc_zeroed(sizeof(tit_ButtonData_t)); //alloc memory and return the adress of the new block
    }
    if (EmptyBlock) {
        EmptyBlock->Next = InputAreas_Used;          // the EmptyBlock->next points on the old first inputArea block
        InputAreas_Used = EmptyBlock;                // the EmptyBlock is the first element of the list now
    }

    return (void*) EmptyBlock;
}

//} Function definitions
