#ifndef TTC_SWITCHES_H
#define TTC_SWITCHES_H

/*{ ttc_switches.h ************************************************
 *
 *  Platform independent support for input switches.
 *
 *  written by Gregor Rebel 2012
 *
}*/
//{ Defines/ TypeDefs ****************************************************


//} Defines
//{ Includes *************************************************************

#include "ttc_gpio.h"
//X #include <stdlib.h>

//} Includes
//{ Structures/ Enums ****************************************************

typedef struct {
    ttc_Port_t  Port;
    union {
      u8_t 
      IsLowActive;
    };
    
} __attribute__((__packed__)) ttc_Switch_t;

//}
//} Structures/ Enums

//{ Global Variables *****************************************************



//} Global Variables
//{ Function prototypes **************************************************

/* initializes a port as input for a connected push button
 * @param Switch       structure which will be filled with all required data (must be kept to use switch later!)
 * @param GPIOx        Port where switch is connected to (GPIOx+Pin can be given as Macro Pin_Pxn (see pin shortcuts in stm32_gpio.h) 
 * @param Pin          Port-Pin  where switch is connected to
 * @param Type         one from enum ttc_gpio_mode_e in ttc_gpio_types.h
 * @param IsLowActive  =true: switch is pressed (active) when input voltage is 0V, Vcc otherwise
 * @
 */
void initPushButton(ttc_Switch_t* Switch, ttc_GPIO_BANK GPIOx, u32_t Pin, ttc_gpio_mode_e Type, BOOL IsLowActive);


//} Function prototypes

#endif //TTC_SWITCHES_H
