/*{ regression_memory_pools.h ************************************************
 
  Regression test for memory pool driver
  written by Gregor Rebel 2013
 
}*/
#ifndef regression_memory_pools_H
#define regression_memory_pools_H

//{ Includes *************************************************************

#include "ttc_basic.h"
#include "ttc_task.h"
#include "ttc_string.h"
#include "ttc_memory.h"
#include "ttc_gfx.h"
#include "ttc_random.h"
#include "ttc_queue.h"

//} Includes
//{ Defines/ TypeDefs ****************************************************

#ifndef EXTENSION_500_ttc_gfx
  #error Missing EXTENSION_500_ttc_gfx !
#endif

//} Defines

typedef struct {
    u8_t X;
    u8_t Y;
    const char* Format;
    u32_t Value;
} printJob_t;

//{ Function prototypes **************************************************

// enqueues print job
void printAt(u8_t X, u8_t Y, const char* Format, u32_t Value);

void taskPrint(void* Arg);

// basic hardware intialization
void regression_init_memory_pools();

// main entry: initializes hardware + spawns all threads
// returns immediately
void regression_start_memory_pools();

// main task controlling LCD-panel
void task_LCD(void *pvParameters);

//} Function prototypes
#endif //regression_memory_pools_H
