#ifndef EXAMPLE_THREADING
#define EXAMPLE_THREADING

/*{ TemplateName::.h ************************************************
 
 Empty template for new header files.
 Copy and adapt to your needs.
 
}*/
//{ Defines/ TypeDefs ****************************************************

#define LED_STAT1 GPIOC, 6
#define LED_STAT2 GPIOC, 7

//} Defines
//{ Includes *************************************************************

 // Basic set of helper functions
#include "ttc_basic.h"
#include "ttc_gpio.h"
#include "ttc_task.h"
#include "ttc_queue.h"
#include "ttc_memory.h"
#include "ttc_gfx.h"
#include "ttc_string.h"

//} Includes
//{ Structures/ Enums ****************************************************

typedef struct { // et_PrintJob_t
    // Column == -1 | Row == -1: continue at last position
    s8_t Column;   // >= 0: Column to move cursor to
    s8_t Row;      // >= 0: Row to move cursor to
    char Text[10]; // zero terminated string to print
    s32_t Value;   // passed as value to printf
} et_PrintJob_t;

/** data being sent to taskProducer()/ taskConsumer() */
typedef struct { // et_ThreadInfo_t
    ttc_QueueHandle QueueProducer2Consumer;
    ttc_QueueHandle QueuePrint;
} et_ThreadInfo_t;

//} Structures/ Enums
//{ Global Variables *****************************************************



//} Global Variables
//{ Function prototypes **************************************************

// basic initialization (called from threading_start() )
void threading_init();

// run demo
void threading_start();

// produces tasks to do
void taskProducer(void *pvParameters);

// consumes + executes tasks to do
void taskConsumer(void *pvParameters);

// adds given data as new print job to given queue
// Will block if queue is full
void queuePrintJob(ttc_QueueHandle PrintQueue, s8_t Column, s8_t Row, const char* Text, s32_t Value);

// central print task (display cannot be used from multiple tasks
void taskPrint(void *pvParameters);


//} Function prototypes

#endif //EXAMPLE_THREADING
