#!/bin/bash
#
# Start OpenOCD GDB server + connect to it
#
# written by Fernando Carmona Varo 2012


[ -e required_version ] || { echo "You need to be in the project directory"; exit 1;}

pgrep openocd 2>&1 || { 

    {   _/gdb_server.sh >&2 2> gdb_server.log
	echo "$0: server exited, with error code $?"
	#tail gdb_server.log 
	pkill $0 # kill also the client
    } > /dev/stderr &

    [ $TERM != "dumb" ] && echo -e "\e[33m** Waiting for server...\e[0m"
    while ! pgrep openocd 2>&1
    do sleep 0.5; done
}


[ $TERM != "dumb" ] && echo -e "\e[33m** Starting gdb\e[0m"
_/gdb.sh main.elf $@

