#!/bin/bash
#
# (c) Gregor Rebel 2010-2011

FILE="$1"

source configs/interface.cfg

if [ "$FILE" == "" ]; then
  echo "$0 FLASHFILE"
  exit 10
fi

if [ ! -e "$FILE" ]; then
  echo "$0 - ERROR: Cannot read flash-file '$FILE'!"
  exit 11
fi

if [ "$FILE" != "main.bin" ]; then
  # flash script always wants to flash file main.bin!
  cp -v "$FILE" main.bin
fi
  
Script2="flash.sh"
cat >$Script2 <<END_OF_TEXT
#!/bin/bash

ERROR=""
source ./_/openocd.sh "-f additionals/999_open_ocd/interface/$Interface -f configs/openocd_target.cfg -f configs/openocd_flash.cfg"
if [ "\$Error" != "" ]; then
  echo ""
  echo "ERROR: Cannot flash $FILE onto uC"
fi

END_OF_TEXT

source ./$Script2

if [ "$Error" != "" ]; then 
  #echo "$0 - ERROR: $ERROR"
  exit 10
else
  rm $Script $Script2
fi


